// Wingman Special (PC88) t@CovO

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <direct.h>
#include "d88.h"

static unsigned char dir[0x100*15];				// Directory (256byte x 15sector)
static unsigned char buff[0x100*16*80];			// 256byte x 16sector x 80track
static char dirpath[FILENAME_MAX];				// 쐬fBNg
static char fname[FILENAME_MAX];				// ؂ot@C

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

int main(int argc, char *argv[])
{
	int d,i,fn;
	int trk,sec,start,end,size;
	bool dirmode = true;

	if (argc < 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file] [-d][-s][-h]\n",argv[0]);
		fprintf(stderr, "       -d  : fBNg쐬Ȃ\n");
		return 1;
	}
	if (argc > 2)
	{
		for (i=2; i<argc; i++)
		{
			if (!strcmp(argv[i],"-d")) dirmode = false;
		}
	}

	// t@CJG[ɂȂ
	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);

		// fBNg̓ǂݍ
		memset(dir,0,sizeof(dir));
		if (disk.ReadDATA(0x01, 0x00, 0x01, 0x01, 0x01, dir, sizeof(dir)) != sizeof(dir))
		{
			fprintf(stderr, "fBXN %d ڂ̃fBNg̓ǂݍ݂Ɏs܂.\n", d+1);
			break;
		}

		if (dirmode)
		{
			sprintf(dirpath,"%03d",d);		// fBNg̐
			_mkdir(dirpath);
			_chdir(dirpath);
			printf("\n[%s] -> %s\n",disk.GetDiskName(),dirpath);
		}

		for (fn=0; fn<(sizeof(dir)/0x10); fn++)
		{
			unsigned char *ent = &dir[fn*0x10];
			if (ent[0] == 0xff) break;		// fBNg̍Ō

			char fname[FILENAME_MAX];		// t@C

			int i;
			int fnp = 0;
			for (i=0; i<6; i++)
			{
				char c = ent[i];		// t@CPo
				if (c==' ') break;
				fname[fnp++] = c;		// t@C\
			}
			fname[fnp++] = '.';			// gq
			for (i=6; i<9; i++)			// gqo
			{
				char c = ent[i];
				if (c==' ') break;
				fname[fnp++] = c;
			}
			fname[fnp++] = '\0';		// ̍Ō

			trk = ent[0x09];
			sec = ent[0x0a];
			start = ent[0x0b] + ent[0x0c]*0x100;
			end   = ent[0x0d] + ent[0x0e]*0x100;
			size  = end-start;

			// ؂o
			if (fcut(fname, trk, trk>>1, trk&1, sec, 0x01, 0, size))
			{
				printf("%-12s  TRK:%02x SEC:%02x %04x-%04x (%04x)\n",fname,trk,sec,start,end,size);
			}
		}
		if (dirmode) _chdir("..");		// efBNg
	}
	return 0;
}
